/******************************************************************************
 ADC1.c
 A/D-Converter Routine for own Channel                                      
																			  
    											PHYTEC Messtechnik GmbH, 1999 
*******************************************************************************/

#pragma large			       		   /* use memory model 'large'            */

#include <REG167.H>                    /* Register Set of 80C167 controller   */
#include <stdio.h>                     /* Standard I/O functions              */

unsigned int Result;

                                                                
/***** main program ***********************************************************/

void main (void)  {                    /* execution starts here               */

/* init serial0 port:                  					      				  */
  P3  |= 0x0400;                       /* set port 3.10 output latch (TXD)    */
  DP3 |= 0x0400;                       /* configure port 3.10 for output      */
                                       /* operation. ( TXD output)            */
  DP3 &= 0xF7FF;                       /* configure port 3.11 for input       */
                                       /* operation. ( RXD input)             */
  S0TIC = 0x80;                        /* set transmit interrupt flag         */
  S0RIC = 0x00;                        /* delete receive interrupt flag       */
  S0BG  = 0x40;                        /* set baudrate to 9600 baud           */
  S0CON = 0x8011;                      /* set serial mode                     */

 
  putchar(' ');                        /* send dummy-Byte for compatibility   */
/* end of init serial0 port:                  				      			  */

  printf ("\Measure\n");         

  while(1)
  {
/* init AD-Converter							      						  */
    ADCON = 0x00;		       			/* A/D-Converter: Channel0, Single    */	
				         				/* Channel Conversion		      	  */
    ADST = 1;			       			/* Conversion start		      		  */

      while(ADBSY);		       			/* wait of end of conversion	      */
   
	Result = ADDAT & 0x03FF;			/*read result of conversion 	      */
    printf("AD-Value = %4u\r",Result);
  }
}

