/*********************************************************************
 ADC4.c
                                                                   
   A/D-Converter in Single Channel Continuous Mode for Channel 0    
   with Channel Injection on Channel 2 started per Software         

         							PHYTEC Metechnik GmbH 2000
 *********************************************************************/
/* ----- Include Dateien: ------------------------------------------ */
#include <REG167.H>          /* Register Definition for C167         */
#include <INTRINS.H>         /* Device specific functions            */
#include <STDIO.H>			 /* Standard I/O functions               */
#include "ASC0_lib.h"        /* serial interface function			 */

/* ----- C-global Byte-/Word-Objects: ----------------------------- */
unsigned int ad_injected;   
unsigned int ad_value;
unsigned char command;

/* ----- AD-Conversion ready interrupt program --------------------- */
void ad (void) interrupt 0x28
{
   ad_value = ADDAT & 0x3ff;	  /* read result of conversion without
								     channel number		             */
}

/* ----- AD-Conversion Error Interrupt program: -------------------- */
void ade_int ( void ) interrupt 0x29
{  
   ad_injected = ADDAT2 & 0x3ff; /* Result only, without Channel
									number	    				    */
   printf("AD Injected = %4u \n",ad_injected);
}

/* ----- main program: -------------------------------------------- */
void main ( )
{  

   serial(57600);            /* Init serial interface for 9600 baud  */
   putchar(' ');             /* Send dummy-Byte for compatibility    */
   
   /* The analog inputs is always define as inputs                   */

   ADCON  = 0x610;           /* Init A/D Converter for Single Channel
								Continuous Conversion on Channel 0,
								enable "Wait for Read and Channel
								Injection           */
   ADDAT2 = 0x2000;          /* Channel Injection on Channel 2       */
   ADEIC  = 0x62;            /* Init Channel-Injection-Interrupt     */
   ADCIC  = 0x63;            /* Init AD-Convesion ready interrupt    */
   ADST   = 1;               /* Start A/D-Conversion                 */

   IEN   = 1;                /* enable global interrupt              */

   printf("press any key to see a conversion result on channel 0 \n space key insert the conversion on channel 2 \n key 'e' stop single continuous conversion for channel 0 \n");  

   while (1)                 /* Endless loop                         */
   {
      /* Here your program                                           */

      command = getchar();
	  if(command == ' ')
            ADCRQ = 1;       /* Start Channel Injection              */
      if(command == 'e')
	        ADST = 0;
	  printf("AD Value = %4u \r",ad_value);

      
      /* Here your program                                           */
   } 
}