/*
;***************************************************************************
;
;  Include file for Phytec's CAN-Treiber C167C Basic/Full-CAN
;
;  (c) PHYTEC Metechnik GmbH 1995
;
;***************************************************************************
;
;  can167.h              V1.03      31.05.95
;
;***************************************************************************
;
;  Aimo S            * 14.02.95 - up to date *
;
;***************************************************************************
*/

#ifndef _CAN167_DRV
#define _CAN167_DRV


#ifndef BYTE
   #define BYTE  unsigned char
#endif

#ifndef WORD
   #define WORD  unsigned short
#endif

#ifndef LONG
   #define LONG  unsigned long
#endif

/* Driver functions */

extern          void        WriteBlock(BYTE,BYTE,BYTE huge *);
extern          void        ReadBlock(BYTE,BYTE,BYTE huge *);
extern          BYTE        WriteByte(BYTE,BYTE);
extern          BYTE        ReadByte(BYTE);
extern          BYTE        WriteWord(BYTE,WORD);
extern          WORD        ReadWord(BYTE);
extern          void        SetID(BYTE,WORD);
extern          void        SetCMR(BYTE,WORD);
extern          WORD        GetCMR(BYTE);
extern          BYTE        GetSR(void);
extern          void        SetSR(BYTE);
extern          BYTE        GetIR(void);
extern          void        SetCR(BYTE);
extern          BYTE        GetCR(void);
extern          void        InitCANInterface(BYTE,BYTE);
extern          void        SetIDAcceptance(WORD, WORD, WORD);

/* Definitions of addresses for can-register  */

#define         CR     0x00
#define         SR     0x01
#define         IR     0x02
#define         BTR0   0x04
#define         BTR1   0x05
#define         GMS    0x06
#define         UGML   0x08
#define         LGML   0x0A
#define         UMLM   0x0C
#define         LMLM   0x0E
#define         MQ1    0x01
#define         MQ2    0x02
#define         MQ3    0x03
#define         MQ4    0x04
#define         MQ5    0x05
#define         MQ6    0x06
#define         MQ7    0x07
#define         MQ8    0x08
#define         MQ9    0x09
#define         MQ10   0x0A
#define         MQ11   0x0B
#define         MQ12   0x0C
#define         MQ13   0x0D
#define         MQ14   0x0E
#define         MQ15   0x0F

#endif 




