/*********************************************************************
  PWM2.c for PHYTEC mM167          												 
                                                                 
  The PWM-Unit generate a PWM-Signal on PWM-Channel 1 Center Aligned
   PWM with variable frequecy (period) and puls width from 1/2 of 
   period dependent from AD-Converter value an AD-Channel 1.
  The PWM-Timer 1 work with CPU-Clock (20 MHz)                     
  The period register contain the start value 40000:                     
      Period a PWM-Signal = 20 MHz / 2 * (40000-1) = 250 Hz    
      Output at Port pin P7.1/POUT1 High-aktive (pin B42).              

									 PHYTEC Messtechnik GmbH, 1999
 *********************************************************************/
#pragma mod167
/* -------Including Files: ----------------------------------------- */
#include <REG167.H>          /* Register defin for C167              */
sbit DP71 = DP7^1;           /* Bitname DP71 for DP7.1 define        */
#include <INTRINS.H>         /* Prototyping of specific Funktionen 
								for C176   							 */

/* --------------------------AD-Converter----------------------------*/
unsigned int ad_conv (unsigned char ADC_Channel)
{
unsigned int Result;
/* init AD-Converter												 */
 ADCON = 0x00 + ADC_Channel;   /* A/D-Converter: Channel0, Single    */	
				       		   /* Channel Conversion		      	 */
   ADST = 1;			       /* Conversion start		      		 */
     while(ADBSY);		       /* wait of end of conversion	      	 */
   Result = ADDAT & 0x03FF;	   /*read result of conversion 			 */
 return Result;
}

/* ------ main Program: -------------------------------------------  */
void main (void)
{  
   DP71  = 1;                /* Define PWM-Output as Push-/Pull-
                                Output, Latch-contents after Reset 0 */
   PM1   = 1;                /* PWM-Channel 1 Center Aligned Mode    */
   PP1   = 40000;	         /* Load period register                 */
   PW1   = 20000;            /* Load puls width register             */
   PEN1  = 1;                /* P7.1/POUT1 release                   */
   PTR1  = 1;                /* Start of PWM-Timer 1                 */

   while (1)                 /* endless loop	                     */
   {
      PP1 = (ad_conv(0)<<6); /* load period register with new value  */
	  PW1 = PP1>>1;			 /* load Puls withe register with 1/2 
								of period					         */
   } 
}
/* -- End of program ----------------------------------------------- */
