/*********************************************************************
  PWM5.c for PHYTEC mM167          												 
                                                                 
  The PWM-Unit generate a PWM-Signal on PWM-Channel 0 Edge Aligned
  in Burst Mode
  The PWM-Timer 0 and 1 work with CPU-Clock (20 MHz)                     
  The period register PP0 contain the value 60000:                     
   Period a PWM-0-Signal = 20 MHz /(60000-1) = 333 Hz and HIGH-puls
   width from 3/4 of period.
  The period register PP1 contain the value 15000:                     
   Period a PWM-1-Signal = 20 MHz /(15000-1) = 1333 Hz and HIGH-puls
   width from 1/2 of period.
   Output at Port pin P7.0/POUT0 High-aktive (pin B40).

									 PHYTEC Messtechnik GmbH, 1999
**********************************************************************/
#pragma mod167
/* -------Including Files: ----------------------------------------- */
#include <REG167.H>          /* defin Register for C167              */
sbit DP70 = DP7^0;           /* Bitname DP70 for DP7.0 define        */
sbit DP71 = DP7^1;           /* Bitname DP71 for DP7.1 define        */
#include <INTRINS.H>         /* Prototyping of specific Funktionen 
								for C176   							 */

/* ------ main Program: -------------------------------------------  */
void main (void)
{ 
   DP70  = 1;				 /* Define PWM-Output as Push-/Pull-     */
   DP71  = 1;                /* Output, Latch-contents after Reset 0 */	
   PP0   = 60000;			 /* Load period register for PWM 0       */
   PP1   = 15000;	         /* Load period register for PWM 1       */
   PW0   = 16000;			 /* Load puls width register for PWM 0   */
   PW1   = 7500;             /* Load puls width register for PWM 1   */
   PWMCON1 = 0x1003;		 /* P7.0/POUT0 and P7.1/POUT1 release,
                                PWM-Mode 0 Edge Aligned PWM and 
 							    Brust PWM							 */
   PWMCON0 = 0x0003;		 /* Start Timer 0 and 1 synchronous,
   								no interrupts						 */

   while (1)                 /* endless loop	                     */
   {
    /* your program code											 */
   } 
}
/* -- End of program ----------------------------------------------- */