/* ********* Beispiel des UART SCC2691 fr das miniMODUL-167 ******* */
/*                                                                   */
/* V 1.1 / 12.02.98 MS/BH                                            */
/* Revisions:                                                        */
/*                                                                   */
/* (c) 1998 PHYTEC Messtechnik GmbH                                  */
/* ***************************************************************** */
#pragma large
#pragma MOD167 FIX167             /* only for MM167 */
#include <reg167.h>
#include <stdio.h>                /* standard I/O .h-file              */
#include <absacc.h>    
#include "uart.h"


/*************************************************************************/
/* FUNCTION main                                                         */
/* Demo fr UART als serielle Schnittstelle.                             */
/*************************************************************************/

void main (void)  {               /* execution starts here               */
char c; 
                                  /* initialize the serial interface UART */
ADDRSEL4 = 0x4000;      /* UART at adr. 0x400000 for 4kByte */
BUSCON4 = 0x040B;       /* select C167 BUS for external UART SCC2691 */
init_UART(0xBE);        /* init UART to 9600bps, 8-data, no-parity, 1-stop */
// init_UART(0xDE);        /* init UART to 19200bps, 8-data, no-parity, 1-stop */
// init_UART(0xFE);        /* init UART to 38400bps, 8-data, no-parity, 1-stop */


  while (1) {                    /* An embedded program does not stop and    */
    printf ("\nHello World: ");  /* the 'printf' function call               */
    c = getchar();
    printf (" char = %c:%02Xh ", c, c);
    /* ... */                   /* never returns.  We've used an endless    */
  }                             /* loop.  You may wish to put in your own   */
}                               /* code were we've printed the dots (...).  */
