/*************************************************************************/
/* Headerfile fr UART - Treiber miniMODUL-167                           */
/*                                                                       */
/* Version 1.0                                                           */
/* 06.08.94                                                              */
/* D. Heger                                                              */
/*                                                                       */
/* (c) 1994 PHYTEC Messtechnik GmbH Mainz                                */
/*************************************************************************/
#define word unsigned int
#define byte unsigned char


extern void wr_UART (byte adr, byte dat);
    /* write byte to UART adr. */

extern byte rd_UART (byte adr);
    /* read byte from UART adr. */

extern byte getstat_UART (void);
    /* read statusregister byte from receiver */
    /* bits: rx_brk, frm_er, par_er, ovr_er, txemt, txrdy, ffull, rxrdy */

extern void init_UART (byte inttype);
    /* init UART with one of this modes:
    bit7..5 = baudrate + bit4..3 = data + bit2..1 = Parity + bit0 = Stopbit
    00h 000 =   300bps + 00h 00 = 5 BIT +  00h 00 = Even   + 00h 0 = 1
    20h 001 =   600bps + 08h 01 = 6 BIT +  02h 01 = Odd    + 01h 1 = 2
    40h 010 =  1200bps + 10h 10 = 7 BIT +  04h 10 = Mark
    60h 011 =  2400bps + 18h 11 = 8 BIT +  06h 11 = No
    80h 100 =  4800bpd
    A0h 101 =  9600bps
    C0h 110 = 19200bps
    E0h 111 = 38400bps
    i.e. inittype = 0xBE = 9600bps, 8-Databit, No-Parity, 1-Stopbit
    */

extern byte rdrx_UART (void);
    /* read byte from rx_buf without status check */

extern byte getc_UART (void);
    /* read byte from receiver with status check */

extern void wrtx_UART (byte dat);
    /* write byte to tx_buf without status check */

extern void putc_UART (byte dat);
    /* write byte to transmitter with status check */


#define RxFLAG (getstat_UART() & 0x01)
#define TxFLAG (getstat_UART() & 0x04)

