/*

   (c) PHYTEC Messtechnik GmbH Germany

   */

#pragma MOD167 FIX167
#include <reg167.h>

/* sytem include */

#include<stdio.h>


/* can functions */

#include "can167.h"


/* arrays */

#define DataSize 8   /* max. 8 Byte Data */


BYTE TxData[DataSize];  /* Databox */

/* functions */


void init_task(void)
     {


         SetCR(0x41);
         SetSR(0x00);
         InitCANInterface(0x44,0x1C);   
         // 1MBit/s:BTR0 = 0x80, BTR1=0x16
         // 125kBit/s: BTR0 = 0x44, BTR1=0x1C
         SetIDAcceptance(0xFFFF,0,0); /*must-match, Broadcast */

         SetCMR(MQ1,0x5995); //TxBuffer disable
         SetID(MQ1,100); /* Identifier in TBF */
         WriteByte(0x16,0x88); /* DLC, transmit, standart */
          
         SetCMR(MQ2,0x5955);
         SetCMR(MQ3,0x5955);
         SetCMR(MQ4,0x5955);
         SetCMR(MQ5,0x5955);
         SetCMR(MQ6,0x5955);
         SetCMR(MQ7,0x5955);
         SetCMR(MQ8,0x5955);
         SetCMR(MQ9,0x5955);
         SetCMR(MQ10,0x5955);
         SetCMR(MQ11,0x5955);
         SetCMR(MQ12,0x5955);
         SetCMR(MQ13,0x5955);
         SetCMR(MQ14,0x5955);

         SetCMR(MQ15,0x5599);
	  SetID(MQ15,101); /* Identifier in TBF */
	  WriteByte(0xF6,0x80); /* DLC, transmit, standart */

         SetCR(0x00);
         SetSR(0x00);

            
      }

void write_data(BYTE k)
     {
         BYTE far *TxPtr;
         BYTE i;

         SetCMR(MQ1,0x5AFF);
         TxData[0] = 0x49;
         for (i=1; i<8; i++) /* write Databox */
             {
                 TxData[i] = i+k;
             }

         TxPtr  = &TxData[0];
         WriteBlock(0x17,DataSize,TxPtr); /* Daten in TBF */
                                   
         printf ("\nUpdate Data");


     }

void send_data(void)
     {

         WORD status = 0x1000;
         WORD i=0;
                 

         SetSR(0);
         printf ("\n%bu: Status=%0Xh",i++,GetSR());
         SetCMR(MQ1,0xE7FF); /* Start Transmit */

         do
            {
               status = GetCMR(MQ1); /* Wait for TBF available */
            } while((status&0x2000));

         printf ("\nTransmision end\n");

      }
                                

void wait_for_message(void)
     {

	  WORD status;
	  BYTE  i;
	  BYTE Offset=0xF7;

	  do {
		status =GetCMR(MQ15);
	  }while ((status & 0x0002) == 0); /* Wait if Message received */

	  SetCMR(MQ15,0xFDFD);
	  printf("\nID = %0Xh",
		((WORD)ReadByte(0xF2) << 3) + ((WORD)ReadByte(0xF3) >> 5) );

//          printf("\nID = %0Xh",ReadWord(0xF2));

          printf ("\nData:  ");

          for (i=0; i<8; i++)
              {
                printf(" %0Xh",ReadByte(Offset++));
              }

          printf("\n");
           
          SetSR(0);


     }

void main(void)
{

   BYTE k;
                                  /* initialize the serial interface     */
   P3  |= 0x0400;        /* SET PORT 3.10 OUTPUT LATCH (TXD)              */
   DP3 |= 0x0400;        /* SET PORT 3.10 DIRECTION CONTROL (TXD OUTPUT)  */
   DP3 &= 0xF7FF;        /* RESET PORT 3.11 DIRECTION CONTROL (RXD INPUT) */
   S0TIC = 0x80;         /* SET TRANSMIT INTERRUPT FLAG                   */
   S0RIC = 0x00;         /* DELETE RECEIVE INTERRUPT FLAG                 */
   S0BG  = 0x40;         /* SET BAUDRATE TO 9600 BAUD                     */
   S0CON = 0x8011;       /* SET SERIAL MODE                               */

   printf("\n\t(c) PHYTEC Messtechnik \n");
   printf("\n\tDemoprogram for CAN-Transmision \n");

   init_task();

  while (1)
      {
      write_data(k++);
      send_data();
//      wait_for_message();
      }

}

   




